const request = require('request-promise');

module.exports = (cookieJar, proxy) => new Promise(async (resolve, reject) => {
    try {
        const options = {
            uri: 'https://stockx.com/login',
            headers: {
                'Host': 'stockx.com',
                'upgrade-insecure-requests': '1',
                'user-agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3865.120 Safari/537.36',
                'sec-fetch-mode': 'navigate',
                'sec-fetch-user': '?1',
                'accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3',
                'sec-fetch-site': 'none',
                'accept-language': 'en-US,en;q=0.9'
            },
            jar: cookieJar,
            followAllRedirects: true,
            followRedirect: true,
            resolveWithFullResponse: true
        };

        if (proxy != '') options.proxy = proxy;

        //Fetch login page
        const res = await request(options);

        if (res.statusCode != 200) return reject(`Status code error ${res.statusCode} - Response: ${res.body}`);

        //Get state and client ID
        const state = res.req._header.split('state=')[1].split('&')[0];
        const clientID = res.req._header.split('client=')[1].split('&')[0];

        if (state == undefined || clientID == undefined) return reject("Could not find state or Client ID!");
        return resolve({
            state, 
            clientID
        });
    }
    catch(e){
        reject(e.message);
    };
});