const login = require('./index');
const request = require('request-promise');

module.exports = (user, pass, cookieJar, proxy) => new Promise(async (resolve, reject) => {
    try {
        const stateData = await login.fetchState(cookieJar, proxy);
        const callbackCredentials = await login.submitCredentials(stateData.clientID, stateData.state, user, pass, cookieJar, proxy);

        await login.submitCallback(callbackCredentials.wa, callbackCredentials.wresult, callbackCredentials.wctx, cookieJar, proxy);

        resolve();
    }
    catch(e){
        reject(e);
    };
});