const request = require('request-promise');

module.exports = (wa, wresult, wctx, cookieJar, proxy) => new Promise(async (resolve, reject) => {
    const dataString = `wa=${wa}&wresult=${wresult}&wctx=${wctx}`;
    const options = {
        uri: `https://accounts.stockx.com/login/callback`,
        method: 'POST',
        headers: {
            'authority': 'accounts.stockx.com',
            'cache-control': 'max-age=0',
            'origin': 'https://accounts.stockx.com',
            'upgrade-insecure-requests': '1',
            'content-type': 'application/x-www-form-urlencoded',
            'user-agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3865.120 Safari/537.36',
            'sec-fetch-mode': 'navigate',
            'sec-fetch-user': '?1',
            'accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3',
            'sec-fetch-site': 'same-origin'
        },
        body: encodeURI(dataString),
        jar: cookieJar,
        followAllRedirects: true,
        followRedirect: true,
        simple: false,
        resolveWithFullResponse: true
    };

    if (proxy != '') options.proxy = proxy;

    //Go through stockX callback
    const res = await request(options)
    .catch(err => reject(err.message));

    if (res.statusCode != 200) return reject(`Status code error ${res.statusCode} - Response: ${res.body}`);
    return resolve();
});