const request = require('request-promise');

module.exports = (query, dataType, options, proxy) => new Promise(async (resolve, reject) => {
    const limit = options == undefined ? 'NA' : options.limit;
    const uri = dataType == undefined ? `https://stockx.com/api/browse?&_search=${query}` : `https://stockx.com/api/browse?&_search=${query}&dataType=${dataType}`;
    const productArray = [];

    const requestOptions = {
        uri: uri,
        headers: {
            'sec-fetch-mode': 'cors',
            'accept-language': 'en-US,en;q=0.9',
            'authorization': '',
            'x-requested-with': 'XMLHttpRequest',
            'appos': 'web',
            'user-agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3865.120 Safari/537.36',
            'accept': '*/*',
            'authority': 'stockx.com',
            'sec-fetch-site': 'same-origin',
            'appversion': '0.1'
        },
        simple: false,
        resolveWithFullResponse: true
    };

    if (proxy != '') options.proxy = proxy;

    let res;
    try {
        res = await request(requestOptions);
    }
    catch(e){
        return reject(e);
    };

    const body = JSON.parse(res.body);
    
    for (let product of body["Products"]){
        if (limit != 'NA' && limit == productArray.length) break;

        productArray.push({
            name: product.title,
            retail: product.retailPrice,
            releaseDate: product.releaseDate,
            pid: product.styleId,
            uuid: product.market.productUuid,
            image: product.media.imageUrl.split('?')[0],
            urlKey: product.urlKey,
            market: product.market
        });
    };

    if (productArray === []) reject("No products found!");
    else resolve(productArray);
});